Index: CKEditor/trunk/_source/plugins/toolbar/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -60,11 +60,34 @@
 			var itemKeystroke = function( item, keystroke )
 			{
+				var next, nextToolGroup, groupItemsCount;
+
 				switch ( keystroke )
 				{
 					case 39 :					// RIGHT-ARROW
 					case 9 :					// TAB
-						// Look for the next item in the toolbar.
-						while ( ( item = item.next || ( item.toolbar.next && item.toolbar.next.items[ 0 ] ) ) && !item.focus )
-						{ /*jsl:pass*/ }
+						do
+						{
+							// Look for the previous item in the toolbar.
+							next = item.next;
+
+							if ( !next )
+							{
+								nextToolGroup = item.toolbar.next;
+								groupItemsCount = nextToolGroup && nextToolGroup.items.length;
+
+								// Bypass the empty toolgroups.
+								while ( groupItemsCount === 0 )
+								{
+									nextToolGroup = nextToolGroup.next;
+									groupItemsCount = nextToolGroup && nextToolGroup.items.length;
+								}
+
+								if ( nextToolGroup )
+									next = nextToolGroup.items[ 0 ];
+							}
+
+							item = next;
+						}
+						while ( item && !item.focus )
 
 						// If available, just focus it, otherwise focus the
@@ -79,7 +102,28 @@
 					case 37 :					// LEFT-ARROW
 					case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
-						// Look for the previous item in the toolbar.
-						while ( ( item = item.previous || ( item.toolbar.previous && item.toolbar.previous.items[ item.toolbar.previous.items.length - 1 ] ) ) && !item.focus )
-						{ /*jsl:pass*/ }
+						do
+						{
+							// Look for the previous item in the toolbar.
+							next = item.previous;
+
+							if ( !next )
+							{
+								nextToolGroup = item.toolbar.previous;
+								groupItemsCount = nextToolGroup && nextToolGroup.items.length;
+
+								// Bypass the empty toolgroups.
+								while ( groupItemsCount === 0 )
+								{
+									nextToolGroup = nextToolGroup.previous;
+									groupItemsCount = nextToolGroup && nextToolGroup.items.length;
+								}
+
+								if ( nextToolGroup )
+									next = nextToolGroup.items[ groupItemsCount - 1 ];
+							}
+
+							item = next;
+						}
+						while ( item && !item.focus )
 
 						// If available, just focus it, otherwise focus the
@@ -113,9 +157,14 @@
 						editor.toolbox = new toolbox();
 
-						var output = [ '<div class="cke_toolbox"' ],
+						var labelId = 'cke_' + CKEDITOR.tools.getNextNumber();
+
+						var output = [ '<div class="cke_toolbox" role="toolbar" aria-labelledby="', labelId, '"' ],
 							expanded =  editor.config.toolbarStartupExpanded !== false,
 							groupStarted;
 
 						output.push( expanded ? '>' : ' style="display:none">' );
+
+						// Sends the ARIA label.
+						output.push( '<span id="', labelId, '" class="cke_voice_label">', editor.lang.toolbar, '</span>' );
 
 						var toolbars = editor.toolbox.toolbars,
@@ -153,5 +202,5 @@
 							}
 
-							output.push( '<span id="', toolbarId, '" class="cke_toolbar"><span class="cke_toolbar_start"></span>' );
+							output.push( '<span id="', toolbarId, '" class="cke_toolbar" role="presentation"><span class="cke_toolbar_start"></span>' );
 
 							// Add the toolbar to the "editor.toolbox.toolbars"
@@ -183,5 +232,5 @@
 										if ( !groupStarted )
 										{
-											output.push( '<span class="cke_toolgroup">' );
+											output.push( '<span class="cke_toolgroup" role="presentation">' );
 											groupStarted = 1;
 										}
@@ -248,6 +297,7 @@
 										var contentHeight = parseInt( contents.$.style.height, 10 );
 										var previousHeight = toolboxContainer.$.offsetHeight;
-
-										if ( toolbox.isVisible() )
+										var collapsed = !toolbox.isVisible();
+
+										if ( !collapsed )
 										{
 											toolbox.hide();
@@ -262,4 +312,9 @@
 										}
 
+										// Update collapser symbol.
+										collapser.getFirst().setText( collapsed ?
+											'\u25B2' :		// BLACK UP-POINTING TRIANGLE
+											'\u25C0' );		// BLACK LEFT-POINTING TRIANGLE
+
 										var dy = toolboxContainer.$.offsetHeight - previousHeight;
 										contents.setStyle( 'height', ( contentHeight - dy ) + 'px' );
@@ -272,10 +327,12 @@
 
 							output.push( '<a title="' + ( expanded ? editor.lang.toolbarCollapse : editor.lang.toolbarExpand )
-													  + '" id="' + collapserId + '" class="cke_toolbox_collapser' );
+													  + '" id="' + collapserId + '" tabIndex="-1" class="cke_toolbox_collapser' );
 
 							if ( !expanded )
 								output.push( ' cke_toolbox_collapser_min' );
 
-							output.push( '" onclick="CKEDITOR.tools.callFunction(' + collapserFn + ')"></a>' );
+							output.push( '" onclick="CKEDITOR.tools.callFunction(' + collapserFn + ')">',
+										'<span>&#9650;</span>',		// BLACK UP-POINTING TRIANGLE
+										'</a>' );
 						}
 
@@ -298,5 +355,5 @@
 	render : function( editor, output )
 	{
-		output.push( '<span class="cke_separator"></span>' );
+		output.push( '<span class="cke_separator" role="separator"></span>' );
 		return {};
 	}
Index: CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js	(revision 5189)
@@ -242,8 +242,9 @@
 				? editor.config.enterMode == CKEDITOR.ENTER_DIV ? 'div' : 'p' : false;
 
+			var frameLabel = editor.lang.editorTitle.replace( '%1', editor.name );
+
 			editor.on( 'editingBlockReady', function()
 				{
 					var mainElement,
-						fieldset,
 						iframe,
 						isLoadingData,
@@ -252,4 +253,5 @@
 						fireMode;
 
+
 					// Support for custom document.domain in IE.
 					var isCustomDomain = CKEDITOR.env.isCustomDomain();
@@ -260,81 +262,49 @@
 						if ( iframe )
 							iframe.remove();
-						if ( fieldset )
-							fieldset.remove();
 
 						frameLoaded = 0;
+
+						var setDataFn = !CKEDITOR.env.gecko && CKEDITOR.tools.addFunction( function( doc )
+							{
+								CKEDITOR.tools.removeFunction( setDataFn );
+								doc.write( data );
+							});
+
+						var srcScript =
+							'document.open();' +
+
+							// The document domain must be set any time we
+							// call document.open().
+							( isCustomDomain ? ( 'document.domain="' + document.domain + '";' ) : '' ) +
+
+							// With FF, it's better to load the data on
+							// iframe.load. (#3894,#4058)
+							// But in FF, we still need the open()-close() call
+							// to avoid HTTPS warnings.
+							( CKEDITOR.env.gecko ? '' : ( 'parent.CKEDITOR.tools.callFunction(' + setDataFn + ',document);' ) ) +
+
+							'document.close();';
 
 						iframe = CKEDITOR.dom.element.createFromHtml( '<iframe' +
   							' style="width:100%;height:100%"' +
   							' frameBorder="0"' +
-							( !CKEDITOR.env.webkit ?
-								// Support for custom document.domain in IE.
-								' src="javascript:void((function(){' +
-								'document.open();' +		// To avoid HTTPS warnings.
-								( isCustomDomain ?
-									'document.domain=\'' + document.domain + '\';' : '' ) +
-								'document.close();' +
-								'})())"' : '' ) +
-  							' tabIndex="-1"' +
+  							' src="javascript:void(function(){' + encodeURIComponent( srcScript ) + '}())"' +
+  							' tabIndex="' + editor.tabIndex + '"' +
   							' allowTransparency="true"' +
   							'></iframe>' );
 
-						// Register onLoad event for iframe element, which
-						// will fill it with content and set custom domain.
-						iframe.on( 'load', function( e )
-						{
-							e.removeListener();
-							var doc = iframe.getFrameDocument().$;
-
-							// Custom domain handling is needed after each document.open().
-							doc.open();
-							if ( isCustomDomain )
-								doc.domain = document.domain;
-							doc.write( data );
-							doc.close();
-
-						} );
-
-						var accTitle = editor.lang.editorTitle.replace( '%1', editor.name );
-
-						if ( CKEDITOR.env.gecko )
-						{
-							// Accessibility attributes for Firefox.
-							mainElement.setAttributes(
-								{
-									role : 'region',
-									title : accTitle
-								} );
-							iframe.setAttributes(
-								{
-									role : 'region',
-									title : ' '
-								} );
-						}
-						else if ( CKEDITOR.env.webkit )
-						{
-							iframe.setAttribute( 'title', accTitle );	// Safari 4
-							iframe.setAttribute( 'name', accTitle );	// Safari 3
-						}
-						else if ( CKEDITOR.env.ie )
-						{
-							// Accessibility label for IE.
-							fieldset = CKEDITOR.dom.element.createFromHtml(
-								'<fieldset style="height:100%' +
-								( CKEDITOR.env.ie && CKEDITOR.env.quirks ? ';position:relative' : '' ) +
-								'">' +
-									'<legend style="display:block;width:0;height:0;overflow:hidden;' +
-									( CKEDITOR.env.ie && CKEDITOR.env.quirks ? 'position:absolute' : '' ) +
-									'">' +
-										CKEDITOR.tools.htmlEncode( accTitle ) +
-									'</legend>' +
-								'</fieldset>'
-								, CKEDITOR.document );
-							iframe.appendTo( fieldset );
-							fieldset.appendTo( mainElement );
-						}
-
-						if ( !CKEDITOR.env.ie )
-							mainElement.append( iframe );
+						// With FF, it's better to load the data on iframe.load. (#3894,#4058)
+						CKEDITOR.env.gecko && iframe.on( 'load', function( ev )
+							{
+								ev.removeListener();
+
+								var doc = iframe.getFrameDocument().$;
+
+								doc.open();
+								doc.write( data );
+								doc.close();
+							});
+
+						mainElement.append( iframe );
 					};
 
@@ -343,5 +313,6 @@
 					var activationScript =
 						'<script id="cke_actscrpt" type="text/javascript" cke_temp="1">' +
-							'window.parent.CKEDITOR._["contentDomReady' + editor.name + '"]( window );' +
+							( isCustomDomain ? ( 'document.domain="' + document.domain + '";' ) : '' ) +
+							'parent.CKEDITOR._["contentDomReady' + editor.name + '"]( window );' +
 						'</script>';
 
@@ -351,6 +322,7 @@
 						if ( frameLoaded )
 							return;
-
 						frameLoaded = 1;
+
+						editor.fire( 'ariaWidget', iframe );
 
 						var domDocument = domWindow.document,
@@ -665,4 +637,5 @@
 										config.docType +
 										'<html dir="' + config.contentsLangDirection + '">' +
+										'<title>' + frameLabel + '</title>' +
 										'<head>' +
 											baseTag +
@@ -760,4 +733,15 @@
 				});
 
+			var titleBackup;
+			// Setting voice label as window title, backup the original one
+			// and restore it before running into use.
+			editor.on( 'contentDom', function ()
+				{
+					var title = editor.document.getElementsByTag( 'title' ).getItem( 0 );
+					title.setAttribute( '_cke_title', editor.document.$.title );
+					editor.document.$.title = frameLabel;
+				});
+
+
 			// Create an invisible element to grab focus.
 			if ( CKEDITOR.env.ie )
@@ -767,5 +751,6 @@
 				{
 					ieFocusGrabber = editor.container.append( CKEDITOR.dom.element.createFromHtml(
-					'<input tabindex="-1" style="position:absolute; left:-10000">' ) );
+						// Use 'span' instead of anything else to fly under the screen-reader radar. (#5049)
+						'<span tabindex="-1" style="position:absolute; left:-10000" role="presentation"></span>' ) );
 
 					ieFocusGrabber.on( 'focus', function()
Index: CKEditor/trunk/_source/themes/default/theme.js
===================================================================
--- CKEditor/trunk/_source/themes/default/theme.js	(revision 5181)
+++ CKEditor/trunk/_source/themes/default/theme.js	(revision 5189)
@@ -119,13 +119,15 @@
 					' title="', ( CKEDITOR.env.gecko ? ' ' : '' ), '"' +
 					' lang="', editor.langCode, '"' +
-					' tabindex="' + tabIndex + '"' +
+					' role="application"' +
+					' aria-labelledby="cke_', name, '_arialbl"' +
 					( style ? ' style="' + style + '"' : '' ) +
 					'>' +
-					'<span class="' , CKEDITOR.env.cssClass, '">' +
-						'<span class="cke_wrapper cke_', editor.lang.dir, '">' +
-							'<table class="cke_editor" border="0" cellspacing="0" cellpadding="0"><tbody>' +
-								'<tr', topHtml		? '' : ' style="display:none"', '><td id="cke_top_'		, name, '" class="cke_top">'	, topHtml		, '</td></tr>' +
-								'<tr', contentsHtml	? '' : ' style="display:none"', '><td id="cke_contents_', name, '" class="cke_contents" style="height:', height, '">', contentsHtml, '</td></tr>' +
-								'<tr', bottomHtml	? '' : ' style="display:none"', '><td id="cke_bottom_'	, name, '" class="cke_bottom">'	, bottomHtml	, '</td></tr>' +
+					'<span id="cke_', name, '_arialbl" class="cke_voice_label">' + editor.lang.editor + '</span>' +
+					'<span class="' , CKEDITOR.env.cssClass, '" role="presentation">' +
+						'<span class="cke_wrapper cke_', editor.lang.dir, '" role="presentation">' +
+							'<table class="cke_editor" border="0" cellspacing="0" cellpadding="0" role="presentation"><tbody>' +
+								'<tr', topHtml		? '' : ' style="display:none"', '><td id="cke_top_'		, name, '" class="cke_top" role="presentation">'	, topHtml		, '</td></tr>' +
+								'<tr', contentsHtml	? '' : ' style="display:none"', '><td id="cke_contents_', name, '" class="cke_contents" style="height:', height, '" role="presentation">', contentsHtml, '</td></tr>' +
+								'<tr', bottomHtml	? '' : ' style="display:none"', '><td id="cke_bottom_'	, name, '" class="cke_bottom" role="presentation">'	, bottomHtml	, '</td></tr>' +
 							'</tbody></table>' +
 							//Hide the container when loading skins, later restored by skin css.
@@ -135,6 +137,6 @@
 				'</span>' ].join( '' ) );
 
-			container.getChild( [0, 0, 0, 0, 0] ).unselectable();
-			container.getChild( [0, 0, 0, 0, 2] ).unselectable();
+			container.getChild( [1, 0, 0, 0, 0] ).unselectable();
+			container.getChild( [1, 0, 0, 0, 2] ).unselectable();
 
 			if ( elementMode == CKEDITOR.ELEMENT_MODE_REPLACE )
@@ -168,18 +170,18 @@
 						'" dir="', editor.lang.dir, '"' +
 						' lang="', editor.langCode, '"' +
+						' role="dialog"' +
+						' aria-labelledby="%title#"' +
 						'>' +
 						'<table class="cke_dialog', ' ' + CKEDITOR.env.cssClass,
-							' cke_', editor.lang.dir, '" style="position:absolute">' +
-							'<tr><td>' +
-							'<div class="%body">' +
-								'<div id="%title#" class="%title"></div>' +
-								'<div id="%close_button#" class="%close_button">' +
-									'<span>X</span>' +
-								'</div>' +
-								'<div id="%tabs#" class="%tabs"></div>' +
-								  '<table class="%contents"><tr>' +
-								  '<td id="%contents#" class="%contents"></td>' +
-								  '</tr></table>' +
-								'<div id="%footer#" class="%footer"></div>' +
+							' cke_', editor.lang.dir, '" style="position:absolute" role="presentation">' +
+							'<tr><td role="presentation">' +
+							'<div class="%body" role="presentation">' +
+								'<div id="%title#" class="%title" role="presentation"></div>' +
+								'<a id="%close_button#" class="%close_button" href="javascript:void(0)" title="' +  editor.lang.common.close+'" role="button"><span class="cke_label">X</span></a>' +
+								'<div id="%tabs#" class="%tabs" role="tablist"></div>' +
+								'<table class="%contents" role="presentation"><tr>' +
+								  '<td id="%contents#" class="%contents" role="presentation"></td>' +
+								'</tr></table>' +
+								'<div id="%footer#" class="%footer" role="presentation"></div>' +
 							'</div>' +
 							'<div id="%tl#" class="%tl"></div>' +
@@ -279,5 +281,5 @@
 	var container = this.container,
 		contents = CKEDITOR.document.getById( 'cke_contents_' + this.name ),
-		outer = resizeInner ? container.getChild( 0 ) : container;
+		outer = resizeInner ? container.getChild( 1 ) : container;
 
 	// Resize the width first.
@@ -303,5 +305,5 @@
 CKEDITOR.editor.prototype.getResizable = function()
 {
-	return this.container.getChild( 0 );
+	return this.container.getChild( 1 );
 };
 
Index: CKEditor/trunk/ckeditor.pack
===================================================================
--- CKEditor/trunk/ckeditor.pack	(revision 5181)
+++ CKEditor/trunk/ckeditor.pack	(revision 5189)
@@ -21,4 +21,5 @@
 		'CKEDITOR.ALT' : 4000,
 		'CKEDITOR.NODE_ELEMENT' : 1,
+		'CKEDITOR.NODE_DOCUMENT' : 9,
 		'CKEDITOR.NODE_TEXT' : 3,
 		'CKEDITOR.NODE_COMMENT' : 8,
@@ -131,4 +132,5 @@
 //					'_source/lang/en.js',
 					'_source/plugins/about/plugin.js',
+					'_source/plugins/a11yhelp/plugin.js',
 					'_source/plugins/basicstyles/plugin.js',
 					'_source/plugins/blockquote/plugin.js',
